require "myprocessor/version"

module Myprocessor
  class Error < StandardError; end
    def param_processor(table_name)
      request.query_parameters.each do |key, value|
        if value == "true"
          value = true
        elsif value == "false"
          value = false
        else
          value = value.split(',')
        end
        search_collection(table_name, key, value)
      end
    end
  
    def search_collection(collection, key, value)
      if ActiveRecord::Base.connection.column_exists?(collection.table_name, key)
        result = collection.where("#{key}": value) if collection.present?
        instance_variable_set("@#{collection.first.class.table_name}", result)
      else
        collection
      end
    end
  
    def include_processor
      return false if params[:include].blank?
      params[:include].split(',').map(&:strip).each do | value|
      send(value)
      end
    end
end
